import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {SettleDetail, SettleDetailParam} from './model';

/**
 * 分页查询结算
 */
export async function pageSettleDetail(params: SettleDetailParam) {
  const res = await request.get<ApiResult<PageResult<SettleDetail>>>(
    '/tower/tower-settle-detail/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同列表
 */
export async function listSettleDetail(params?: SettleDetailParam) {
  const res = await request.get<ApiResult<SettleDetail[]>>(
    '/tower/tower-settle-detail',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同
 */
export async function getSettleDetail(id: number) {
  const res = await request.get<ApiResult<SettleDetail>>(
    '/tower/tower-settle-detail/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同
 */
export async function addSettleDetail(data: SettleDetail) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-settle-detail',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同
 */
export async function updateSettleDetail(data: SettleDetail) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-settle-detail',
    data
  );
  if (res.data.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同
 */
export async function updateBatchSettleDetail(data: SettleDetail[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-settle-detail/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
export async function addBatchSettleDetail(data: SettleDetail[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-settle-detail/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同
 */
export async function removeSettleDetail(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-settle-detail/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同
 */
export async function removeBatchSettleDetail(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-settle-detail/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
